//+------------------------------------------------------------------+
//|                                                 TTM original.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  clrSienna
#property indicator_color2  clrSienna
#property indicator_color3  clrRed
#property indicator_color4  clrLimeGreen
#property indicator_color5  clrSienna
#property indicator_color6  clrSienna
#property indicator_color7  clrYellow
#property indicator_color8  clrYellow
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  2
#property indicator_width8  2

//
//
//
//
//

extern int            TTMPeriod = 6;
extern ENUM_MA_METHOD MaMode    = MODE_LWMA;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
double trend[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexBuffer(6,buffer7); SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexBuffer(7,buffer8); SetIndexStyle(7,DRAW_HISTOGRAM);
   SetIndexBuffer(8,trend);
   return(0);
}

//
//
//
//
//

int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
            
   for (i=limit; i>=0; i--)
   {  
       double Low_ma  = iMA(NULL,0,TTMPeriod,0,MaMode,PRICE_LOW,i);
       double High_ma = iMA(NULL,0,TTMPeriod,0,MaMode,PRICE_HIGH,i);
       double close   = iClose(NULL,0,i);
       double L3      = (High_ma- Low_ma) / 3 + Low_ma;
       double H3      = 2 * (High_ma- Low_ma) / 3 + Low_ma;
            
      //
      //
      //
      //
      //
      
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
      buffer3[i] = EMPTY_VALUE;
      buffer4[i] = EMPTY_VALUE;
      buffer5[i] = EMPTY_VALUE;
      buffer6[i] = EMPTY_VALUE;
      buffer7[i] = EMPTY_VALUE;
      buffer8[i] = EMPTY_VALUE;
      trend[i] = 0;   
         if (close > H3)               trend[i] = 1;
         if (close < L3)               trend[i] =-1;
         if (close < H3 && close > L3) trend[i] = 0;
         
         if (trend[i] == -1)
         { 
           buffer1[i] = High[i];
           buffer2[i] = Low[i];
           if (Close[i]>Open[i]) { buffer3[i] = Close[i]; buffer4[i] = Open[i]; }  
           else                  { buffer4[i] = Close[i]; buffer3[i] = Open[i]; }  
         }                   
         if (trend[i] == 1)
         {
            buffer1[i] = Low[i];
            buffer2[i] = High[i];
            if (Close[i]<Open[i]) { buffer3[i] = Close[i]; buffer4[i] = Open[i]; }  
            else                  { buffer4[i] = Close[i]; buffer3[i] = Open[i]; }  
         }                   
         if (trend[i] == 0)
         {
            buffer5[i] = Low[i];
            buffer6[i] = High[i];
            buffer7[i] = Open[i];
            buffer8[i] = Close[i];
         }
   }
   return(0);
}